import httpclient.HTTPClient;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.net.UnknownHostException;
import java.util.Properties;
import java.util.ResourceBundle;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
/*
 * HttpClientPanel.java
 *
 * Created on 8 ottobre 2006, 19.12
 */

/**
 *
 * @author  Giacomo Petronio
 */
public class HttpClientPanel extends javax.swing.JPanel {
    
    HTTPClient client = new HTTPClient();
    Properties settings = new Properties();
    String propfileName = "settings.properties";
    
    
    /** Creates new form HttpClientPanel */
    public HttpClientPanel() {
        initComponents();
        loadProperties();
        
        Runtime.getRuntime().addShutdownHook(
                new Thread(new Runnable() {
            public void run() {
                saveProperties();
            }
        }));
    }
    

    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        buttonGroup1 = new javax.swing.ButtonGroup();
        hostTextField = new javax.swing.JTextField();
        portTextField = new javax.swing.JTextField();
        pathTextField = new javax.swing.JTextField();
        postRadioButton = new javax.swing.JRadioButton();
        getRadioButton = new javax.swing.JRadioButton();
        headerCheckBox1 = new javax.swing.JCheckBox();
        headerCheckBox2 = new javax.swing.JCheckBox();
        headerCheckBox3 = new javax.swing.JCheckBox();
        headerKeyTextField1 = new javax.swing.JTextField();
        headerValueTextField1 = new javax.swing.JTextField();
        headerKeyTextField2 = new javax.swing.JTextField();
        headerValueTextField2 = new javax.swing.JTextField();
        headerKeyTextField3 = new javax.swing.JTextField();
        headerValueTextField3 = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        bodyTextArea = new javax.swing.JTextArea();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();

        hostTextField.setText("localhost");

        portTextField.setText("8084");

        buttonGroup1.add(postRadioButton);
        postRadioButton.setSelected(true);
        postRadioButton.setText("POST");
        postRadioButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        postRadioButton.setMargin(new java.awt.Insets(0, 0, 0, 0));

        buttonGroup1.add(getRadioButton);
        getRadioButton.setText("GET");
        getRadioButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        getRadioButton.setMargin(new java.awt.Insets(0, 0, 0, 0));

        headerCheckBox1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        headerCheckBox1.setMargin(new java.awt.Insets(0, 0, 0, 0));

        headerCheckBox2.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        headerCheckBox2.setMargin(new java.awt.Insets(0, 0, 0, 0));

        headerCheckBox3.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        headerCheckBox3.setMargin(new java.awt.Insets(0, 0, 0, 0));

        bodyTextArea.setColumns(20);
        bodyTextArea.setRows(5);
        jScrollPane1.setViewportView(bodyTextArea);

        jLabel1.setText("hostname");

        jLabel2.setText("port");

        jLabel3.setText("resource");

        jButton1.setText("Send Request");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                                .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                                    .add(headerCheckBox2)
                                    .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                    .add(headerKeyTextField2))
                                .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                                    .add(headerCheckBox1)
                                    .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                    .add(headerKeyTextField1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 138, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                            .add(layout.createSequentialGroup()
                                .add(headerCheckBox3)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(headerKeyTextField3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 138, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(headerValueTextField1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 343, Short.MAX_VALUE)
                            .add(headerValueTextField2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 343, Short.MAX_VALUE)
                            .add(headerValueTextField3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 343, Short.MAX_VALUE)))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(getRadioButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(postRadioButton))
                    .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 506, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(hostTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 171, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel1))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel2)
                            .add(portTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 43, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel3)
                            .add(pathTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 280, Short.MAX_VALUE)))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jButton1))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(jLabel1)
                    .add(jLabel3))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(hostTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(pathTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(portTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(18, 18, 18)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(getRadioButton)
                    .add(postRadioButton))
                .add(20, 20, 20)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(headerCheckBox1)
                    .add(headerKeyTextField1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(headerValueTextField1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(headerCheckBox2)
                    .add(headerKeyTextField2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(headerValueTextField2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(headerCheckBox3)
                    .add(headerKeyTextField3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(headerValueTextField3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 13, Short.MAX_VALUE)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 235, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(16, 16, 16)
                .add(jButton1)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents
    
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        client.setHost(hostTextField.getText(), Integer.parseInt(portTextField.getText()), pathTextField.getText());
        if(getRadioButton.isSelected())
            client.setMethod("GET");
        else
            client.setMethod("POST");
        
        if(headerCheckBox1.isSelected())
            client.addRequestHeader(headerKeyTextField1.getText(), headerValueTextField1.getText());
        if(headerCheckBox2.isSelected())
            client.addRequestHeader(headerKeyTextField2.getText(), headerValueTextField2.getText());
        if(headerCheckBox3.isSelected())
            client.addRequestHeader(headerKeyTextField3.getText(), headerValueTextField3.getText());
        
        client.setBody(bodyTextArea.getText());
        
        String[] result = new String[2];
        
        try {
            result = client.send();
            
            ResultPanel panel = new ResultPanel(result[0], result[1]);
            JDialog dialog = new JDialog();
            dialog.getContentPane().add(panel);
            dialog.setBounds(100,50,800,800);
            dialog.setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
            dialog.setVisible(true);
            
        } catch (UnknownHostException ex) {
            ex.printStackTrace();
            JOptionPane.showMessageDialog(this," Nome host invalido: "+ex.getLocalizedMessage());
        } catch (IOException ex) {
            ex.printStackTrace();
            JOptionPane.showMessageDialog(this,ex.getMessage());
        }
        
        client.removeHeaders();
        
    }//GEN-LAST:event_jButton1ActionPerformed
    
    
    private void loadProperties(){
        try {
            
            FileInputStream fis = new FileInputStream(propfileName);
            settings.load(fis);
            fis.close();
            
            hostTextField.setText(settings.getProperty("host"));
            portTextField.setText(settings.getProperty("port"));
            pathTextField.setText(settings.getProperty("path"));
            
            if (stringToBoolean(settings.getProperty("get")))
                getRadioButton.setSelected(true);
            else
                postRadioButton.setSelected(true);
            
            headerCheckBox1.setSelected(stringToBoolean(settings.getProperty("check1")));
            headerCheckBox2.setSelected(stringToBoolean(settings.getProperty("check2")));
            headerCheckBox3.setSelected(stringToBoolean(settings.getProperty("check3")));
            
            headerKeyTextField1.setText(settings.getProperty("key1"));
            headerKeyTextField2.setText(settings.getProperty("key2"));
            headerKeyTextField3.setText(settings.getProperty("key3"));
            
            headerValueTextField1.setText(settings.getProperty("value1"));
            headerValueTextField2.setText(settings.getProperty("value2"));
            headerValueTextField3.setText(settings.getProperty("value3"));
            
            bodyTextArea.setText(settings.getProperty("body"));
            
        } catch (IOException ex) {
            ex.printStackTrace();
            JOptionPane.showMessageDialog(this, ex.getMessage());
        }
    }
    
    private void saveProperties(){
        
        settings.setProperty("host",hostTextField.getText());
        settings.setProperty("port",portTextField.getText());
        settings.setProperty("path",pathTextField.getText());
        
        settings.setProperty("get",booleanToString(getRadioButton.isSelected()));
        settings.setProperty("post",booleanToString(postRadioButton.isSelected()));
        
        settings.setProperty("check1",booleanToString(headerCheckBox1.isSelected()));
        settings.setProperty("check2",booleanToString(headerCheckBox2.isSelected()));
        settings.setProperty("check3",booleanToString(headerCheckBox3.isSelected()));
        
        settings.setProperty("key1",headerKeyTextField1.getText());
        settings.setProperty("key2",headerKeyTextField2.getText());
        settings.setProperty("key3",headerKeyTextField3.getText());
        
        settings.setProperty("value1",headerValueTextField1.getText());
        settings.setProperty("value2",headerValueTextField2.getText());
        settings.setProperty("value3",headerValueTextField3.getText());
        
        settings.setProperty("body", bodyTextArea.getText());
        
        try {
            settings.store(new FileOutputStream(propfileName),"HttpClient preferences file");
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
    
    private String booleanToString(boolean b){
        if(b)
            return "true";
        else
            return "false";
    }
    
    private boolean stringToBoolean(String s){
        if ( s != null && s.compareTo("true") == 0 )
            return true;
        else
            return false;
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextArea bodyTextArea;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JRadioButton getRadioButton;
    private javax.swing.JCheckBox headerCheckBox1;
    private javax.swing.JCheckBox headerCheckBox2;
    private javax.swing.JCheckBox headerCheckBox3;
    private javax.swing.JTextField headerKeyTextField1;
    private javax.swing.JTextField headerKeyTextField2;
    private javax.swing.JTextField headerKeyTextField3;
    private javax.swing.JTextField headerValueTextField1;
    private javax.swing.JTextField headerValueTextField2;
    private javax.swing.JTextField headerValueTextField3;
    private javax.swing.JTextField hostTextField;
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField pathTextField;
    private javax.swing.JTextField portTextField;
    private javax.swing.JRadioButton postRadioButton;
    // End of variables declaration//GEN-END:variables
    
}
